//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/rsocket/RBenchmark.sj -d tests/classes/
//$ tests/src/benchmarks/macro/rsocket/rbench.sh localhost 8888 10

package benchmarks.macro.rsocket;

import sj.runtime.*;
import sj.runtime.net.*;

public class RBenchmark 
{
	private protocol p { begin.?(Integer).![?(Integer)]* }

	public RBenchmark(String server, int port) throws Exception 
	{		
		SJServerAddress c = SJServerAddress.create(p, server, port);
		SJSocket s = SJRSocket.create(c);

		int id = -1;
		
		long timeStarted = -1;		
		long timeFinished = -1;

		try (s) 
		{							
			s.request();	

			int k = 0;

			id = ((Integer) s.receive()).intValue();

			timeStarted = System.nanoTime();

			s.outwhile (k++ < 1)
			{							
				Integer v = s.receive();							

				//System.out.println("Received: " + v);				
			}	
			
			timeFinished = System.nanoTime();
			
			//System.out.println("Response time: " + ((timeFinished - timeStarted) / 1000));			
			System.out.println(((timeFinished - timeStarted) / 1000));			
		}
		catch (Exception x) { x.printStackTrace(); }
		finally 
		{
			//System.out.println("Finished: " + id);
		}								
	}

	public static void main(String args[]) throws Exception 
	{
		new RBenchmark(args[0], Integer.parseInt(args[1]));
	}	
}
