//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/socket/SocketBenchmark.sj -d tests/classes/
//$ tests/src/benchmarks/macro/socket/sbench.sh localhost 8888 10

package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketBenchmark 
{
	public SocketBenchmark(String server, int port) throws Exception 
	{		
		InetSocketAddress addr = new InetSocketAddress(server, port);					

		Socket s = null;
		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;		
		
		int id = -1;
		
		long timeStarted = -1;		
		long timeFinished = -1;

		try
		{							
			s = new Socket(addr.getAddress(), addr.getPort());		
		
			s.setTcpNoDelay(true);	
			
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());			

			id = ((Integer) ois.readObject()).intValue();							

			timeStarted = System.nanoTime();

			oos.writeBoolean(true);	// Actual run.
			oos.flush();
			
			Integer v = (Integer) ois.readObject();							

			//System.out.println("Received: " + v);			

			oos.writeBoolean(false);
			oos.flush();

			timeFinished = System.nanoTime();
			
			//System.out.println("Response time: " + ((timeFinished - timeStarted) / 1000));			
			System.out.println(((timeFinished - timeStarted) / 1000));			
		}
		catch (Exception x) { x.printStackTrace(); }
		finally 
		{
			System.out.println("Finished: " + id);
		
			close(ois, oos, s);
		}								
	}

	/*private boolean outsync(ObjectOutputStream oos, boolean b) throws IOException
	{
		oos.writeBoolean(b);
		oos.flush();
		
		return b;
	}*/

	public static void main(String args[]) throws Exception 
	{
		new SocketBenchmark(args[0], Integer.parseInt(args[1]));
	}	
	
	private void close(ObjectInputStream ois, ObjectOutputStream oos, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();			
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}		
}
