//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/socket/SocketServer.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.macro.socket.SocketServer 8888 

package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketServer 
{
	private ServerSocket ss = null;
	
	public SocketServer(int port) throws Exception 
	{			
		ss = new ServerSocket(port);
		
		int id = 0;

		Socket s = null;
		
		while (true) 			
		{																											
			try 
			{					
				s = ss.accept();						

				s.setTcpNoDelay(true);			
				
				new ServerThread(id, s).start();
				
				System.out.println("Accepted: " + id++);				
			}
			catch (Exception x)			
			{
				x.printStackTrace();
			}									
		}
	}	

	private class ServerThread extends Thread
	{
		private final Socket s;
		private final ObjectInputStream ois;
		private final ObjectOutputStream oos;
	
		private final int id; 		
	
		public ServerThread(int id, Socket s) throws IOException
		{
			this.id = id;
			
			this.s = s;						
			this.ois = new ObjectInputStream(s.getInputStream());
			this.oos = new ObjectOutputStream(s.getOutputStream());			
		}
	
		public void run()
		{
			try
			{
				oos.writeObject(new Integer(id));
				oos.flush();
			
				int v = 0;
			
				for (boolean redo = ois.readBoolean(); redo; redo = ois.readBoolean()) 
				{								
					oos.writeObject(new Integer(v++));
					oos.flush();
				}			
			}
			catch (Exception x) { x.printStackTrace(); }
			finally
			{
				close(oos, ois, s);			
			}							
		}

		private void close(ObjectOutputStream oos, ObjectInputStream ois, Socket s)
		{
			try
			{
				if (oos != null) oos.close();
				if (ois != null) ois.close();
				if (s != null) s.close();
			}
			catch (IOException ioe) { }	
		}				
	}

	public static void main(String[] args) throws Exception 
	{
		new SocketServer(Integer.parseInt(args[0]));
	}		
}
