//$ bin/sjc tests/src/benchmarks/micro/fns3socket/FNS3Client.sj -d tests/classes/benchmarks/micro/fns3socket/
//$ tests/src/benchmarks/micro/fns3socket.sh localhost 8888

import java.io.*;
import java.net.*;

import sj.types.typeobjects.sesstypes.*;

import sj.runtime.*;
import sj.runtime.net.*;
import sj.runtime.net.alt.*;

public class FNS3Client 
{
	private protocol p 
	{
		begin
		.![ 
			?(BigObject)
		]*
	}	
	
	public FNS3Client(String server, int port, int msgSize, int sessLen) throws Exception 
	{	
		SJServerAddress c = SJServerAddress.create(p, server, port);					
		SJSocket ds = SJFNS3Socket.create(c);			
		SJFNS3Socket s = SJFNS3Socket.create(c);					
			
		dummyrun(server, port);
			
		long timeStarted = -1;		
		long timeFinished = -1;
		
		try (s) // Actual run.
		{
			timeStarted = System.currentTimeMillis();
		
			s.request();					
			
			//timeFinished = System.currentTimeMillis();										
			
			int k = 0;

			boolean foo = false;
			s.outwhile(k++ < sessLen) 
			{
				BigObject bo = s.receive();
			
				/*if (!foo) 
				{
					System.out.println("Received: " + bo);								
					foo = true;
				}*/
			}
						
			timeFinished = System.currentTimeMillis();										
		}
		finally 
		{

		}									

		//System.out.println("Object size " + msgSize + ", session length " + sessLen + ": " + (timeFinished - timeStarted) + "ms.");				
		System.out.println(timeFinished - timeStarted);	
	}

	public static void main(String args[]) throws Exception 
	{
		new FNS3Client(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]));
	}

	void dummyrun(String server, int port) throws Exception
	{		
		SJServerAddress c = SJServerAddress.create(p, server, port);
		SJFNS3Socket bar = SJFNS3Socket.create(c);
		
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;	
	
		try 
		{					
			InetSocketAddress addr = new InetSocketAddress(server, port + 1);
		
			s = new Socket(addr.getAddress(), addr.getPort());		
		
			s.setTcpNoDelay(true);
			
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());

			oos.writeObject(p.encodedSJType());
		
			SJType theirs = bar.decodeSJType((String) ois.readObject()); 
	
			if (!bar.protocolType().treeDualtype(theirs))
			{
				throw new IOException("Foo: " + theirs);
			}
			
			for (int k = 0; k < 1; k++)
			{
				oos.writeBoolean(true);		
				oos.flush();
								
				BigObject bo = (BigObject) ois.readObject();					
			}

			oos.writeBoolean(false);
			oos.flush();
		}
		finally 
		{
			try
			{
				if (oos != null) 
				{
					oos.flush();						
					oos.close();				
				}
				if (ois != null) ois.close();			
				if (s != null) s.close();
			}			
			catch (IOException ioe) { }
		}	
	}	
}
