//$ bin/sjc tests/src/benchmarks/micro/fnssocket/FNSServer.sj -d tests/classes/benchmarks/micro/fnssocket/
//$ bin/sj -cp tests/classes/benchmarks/micro/fnssocket/ FNSServer 8888

import java.io.*;
import java.net.*;

import sj.runtime.*;
import sj.runtime.net.*;
import sj.runtime.net.alt.*;

public class FNSServer 
{
	private static final int[] msgSizes = { 100, 10000 };
	private static final int[] sessLens = { 1, 10, 100, 1000 };

	private protocol p 
	{
		begin
		.?[
			!<BigObject>
		]*
	}	

	public FNSServer(int port) throws Exception 
	{	
		SJServerSocket ss = SJFNSServerSocket.create(p, port);

		int run = 0;
		int id = 0;		

		while(true) 
		{
			System.out.println("Run: " + run++);
		
			SJSocket ds = null;
			SJSocket s = null;

			for (int i = 0; i < msgSizes.length; i++)
			{			
				for (int j = 0; j < sessLens.length; j++)
				{				
					try (ds) // Dummy run.
					{												
						ds = ss.accept();
						
						ds.inwhile() // Not worth moving to another method.
						{
							ds.send(new BigObject(-1, 1000));
						}															
					}
					finally 
					{ 
					
					}														
				
					try (s) // Actual run.
					{												
						s = ss.accept();					
						
						s.inwhile() 
						{
							s.send(new BigObject(id++, msgSizes[i] - 86));
						}															
					}
					finally 
					{ 
					
					}
					
					//System.out.println("Served size " + msgSizes[i] + ", length " + sessLens[j] + ".");					
				}
			}				
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new FNSServer(Integer.parseInt(args[0]));
	}
}
