// bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/rmi/RMIClient.sj -d tests/classes/
// tests/src/benchmarks/micro/rmi/rmi.sh localhost RMIBenchmarkObject 100

package benchmarks.micro.rmi;

import java.io.IOException;
import java.rmi.NotBoundException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import benchmarks.micro.BigObject;

public class RMIClient 
{
	public RMIClient(String rmiRegHost, String remoteObject, int msgSize, int sessLen) throws Exception
	{
		dummyrun();
	
		Registry registry = LocateRegistry.getRegistry(rmiRegHost);
		
		RMIServer remoteServer = (RMIServer) registry.lookup(remoteObject);

		boolean foo = true;
		
		long timeStarted = System.nanoTime();

		for (int k = 0; k < sessLen; k++) 
		{
			BigObject bo = null;
			
			if (msgSize == 100)
			{
				bo = remoteServer.getBigObject100(true);
			}
			else if (msgSize == 10000)
			{
				bo = remoteServer.getBigObject10000(true);
			}
			else
			{
				throw new RuntimeException("Bad BigObject size: " + msgSize);
			}

			/*if (foo)
			{
				System.out.println("Received: " + bo);
				foo = false;
			}*/
		}

		long timeFinished = System.nanoTime();

		//System.out.println("Object size " + msgSize + ", session length " + sessLen + ": " + ((tiMath.round(((float) (timeFinished - timeStarted)) / 1000.0) + "ms.");		
		System.out.println(Math.round(((float) (timeFinished - timeStarted)) / 1000.0));		
	}

	public static void main(String[] args) throws Exception
	{
		new RMIClient(args[0], args[1], Integer.parseInt(args[2]), Integer.parseInt(args[3]));
	}
	
	private void dummyrun() throws Exception
	{
		Registry registry = LocateRegistry.getRegistry("localhost");
		
		RMIServer dummy = (RMIServer) registry.lookup("dummy");

		//dummy.setBigObjectSize(msgSize);
			
		BigObject dummybo = dummy.getDummy(true); 
	}
}
