// bin/sjc tests/src/remclassload/client/AClient.sj -d tests/classes/remclassload/client/
// bin/sj -cp tests/classes/remclassload/client AClient localhost 8888

import java.util.Date;

import sj.runtime.*;
import sj.runtime.net.*;

class AClient 
{
	public static void main(String[] args) throws Exception
	{
		protocol p {
			begin
			.?(String)
			//.!<Address> // Can test lazy downloading.
			.!<AddressImpl> 
		}

		SJServerAddress c = SJServerAddress.create(p, args[0], Integer.parseInt(args[1])); 
		SJSocket s = SJFSocket.create(c);

		s.setCodebase("http://www.doc.ic.ac.uk/~rh105/remclassrep/");		
		s.setRemoteClassLoading(true);
		s.setEagerClassDownloading(true);
		s.setEagerClassVerification(true);
		
		try (s)
		{
			s.request();
			
			System.out.println("Received: " + s.receive());
			
			AddressImpl a = new AddressImpl("An AddressImpl.");
			
			s.send(a);			
		}		
		finally 
		{

		}
	}
}
