//$ bin/sjc tests/src/ticketagency/Agency.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ ticketagency.Agency 9999 localhost 8888

package ticketagency;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

class Agency 
{
	Agency(int port_a, String addr_s, int port_s) throws IOException 
	{
		protocol p_ac 
		{
		  begin.
		  ?[
		  	?(String).!<Double>
		  ]*.
		  ?{
		    ACCEPT: ?(Address).!<Date>,
		  	REJECT:
		  }
		}

		protocol p_as { begin.!<?(Address).!<Date> > } // '>>' is a problem.

		SJServerSocket ss_ac = SJRServerSocket.create(p_ac, port_a);
		
		while (true) 
		{
			SJSocket s_ac = null;

			try (s_ac)
			{
				s_ac = ss_ac.accept();

				s_ac.inwhile() 
				{
					String travDetails = s_ac.receive();

					Double cost = getPrice(travDetails);

					System.out.println("Requested journey: " + travDetails + "; cost: " + cost);

					s_ac.send(cost);
				}

				s_ac.inbranch() 
				{
					case ACCEPT: 
					{
						SJServerAddress c_as = SJServerAddress.create(p_as, addr_s, port_s);
						SJSocket s_as = SJRSocket.create(c_as);

						try (s_as)
						{
							s_as.request();

							s_as.send(s_ac); // No more operations on s_ac allowed. // Similarly if delegation other way round.
						}
						catch (UnknownHostException uhe) 
						{ 
							uhe.printStackTrace(); 
						}					
					}
					case REJECT: 
					{
					
					}
				}
			}		
			catch (SJIOException ioe) 
			{ 
				ioe.printStackTrace();
			}
			catch (SJIncompatibleSessionException stise) 
			{ 
				stise.printStackTrace();
			}			
			catch (ClassNotFoundException cnfe) 
			{ 
				cnfe.printStackTrace();
			}				
		}
	}

	private Double getPrice(String travelMethod) 
	{
		return new Double((new Random().nextInt(20) - 10) + 100.00);
	}

	public static void main(String[] args) throws IOException 
	{
		new Agency(Integer.parseInt(args[0]), args[1], Integer.parseInt(args[2]));
	}
}
